// CppRubyize.cpp : R\[ AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"

IDispatch* create()
{
	CLSID clsid;
	HRESULT hr = ::CLSIDFromProgID(L"ruby.object", &clsid);
	if (hr != S_OK)
	{
		printf("CLSIDFromProgID(ruby.object) = %08X\n", hr);
		return NULL;
	}
    IDispatch* pruby = NULL;
	hr = CoCreateInstance(clsid, NULL, CLSCTX_INPROC_SERVER, IID_IDispatch, (LPVOID*)&pruby);
	if (FAILED(hr))
	{
		printf("CoCreateInstance = %08X\n", hr);
		return NULL;
	}
    return pruby;
}

static LPOLESTR dispname_rubyize[] = {
    L"rubyize",
    L"erubyize",
};
static LPOLESTR dispname_erubyize[] = {
    L"erubyize",
};
static DISPID dispids[] = { DISPID_UNKNOWN, DISPID_UNKNOWN, };

DISPID get_dispid(LPOLESTR dispname, IDispatch* pdisp)
{
	DISPID dispid = DISPID_UNKNOWN;
    HRESULT hr = pdisp->GetIDsOfNames(IID_NULL, &dispname, 1, LOCALE_SYSTEM_DEFAULT, &dispid);
	if (FAILED(hr)) {
        printf("idsofnames failed %08X\n", hr);
		throw hr;
	}
	return dispid;
}

void gsub(IDispatch* pdisp)
{
	DISPID gsub = get_dispid(L"gsub", pdisp);
    VARIANT arg[2];
    VARIANT result;
	VariantInit(&arg[0]);        
	VariantInit(&arg[1]);        
	VariantInit(&result);
	arg[0].vt = arg[1].vt = VT_BSTR;
	arg[0].bstrVal = SysAllocString(L"a");
	arg[1].bstrVal = SysAllocString(L"A");
	DISPPARAMS params = {
		arg, NULL, 2, 0
	};
    EXCEPINFO excep;
    UINT argerr = 0;
    HRESULT hr = pdisp->Invoke(gsub, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_METHOD, &params,
		&result, &excep, &argerr);
	if (FAILED(hr)) {
        printf("gsub failed %08X\n", hr);
	} else {
        printf("result=%ls\n", result.bstrVal);
		VariantClear(&result);
	}
	VariantClear(&arg[0]);
	VariantClear(&arg[1]);
}

void show_string(IDispatch* pruby)
{
	DISPID rubyize = get_dispid(L"rubyize", pruby);
    VARIANT arg;
    VARIANT result;
    VariantInit(&arg);    
	VariantInit(&result);
	arg.vt = VT_BSTR;
	arg.bstrVal = SysAllocString(L"Arton");
	DISPPARAMS params = {
		&arg, NULL, 1, 0
	};
    EXCEPINFO excep;
    UINT argerr = 0;
    HRESULT hr = pruby->Invoke(rubyize, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_METHOD, &params,
		&result, &excep, &argerr);
	if (FAILED(hr)) {
        printf("rubyize failed %08X\n", hr);
	} else {
		gsub(result.pdispVal);
		VariantClear(&result);
	}
	VariantClear(&arg);
}

void destroy(IDispatch* pruby)
{
	pruby->Release();
}

int main(int argc, char* argv[])
{
	CoInitialize(NULL);
	for (int i = 0; i < 2; i++) 
	{
		IDispatch* pruby = create();
		if (pruby)
		{
			show_string(pruby);
			destroy(pruby);
		}
	}
	CoUninitialize();
	return 0;
}
